


#include "calc.h"

float add (float a, float b){
  return a + b ;
}

float sub (float a, float b){
  return a - b ;
}

float mul (float a, float b){
  return a * b ;
}

float divs (float a, float b){
  if ((a == 0.0)  && (b==0)) {
    return NAN;
  }
  if(b==0){
    return INFINITY;
  }
  return a / b ;
}


float calculate(float a, float b, char op){
  switch (op){
  case '+':
    return add (a,b);
    break;
  case '-':
    return sub (a,b);
    break;
  case '*':
    return mul (a,b);
    break;
  case '/':
    return divs (a,b);
    break;
  default :
    return -1;
  }

}

int print_result(float res){

  return printf("Result = %.2f \n", res);
    
}



int is_operator(char op){
  switch (op){
  case '+':
    return 0;
  case '-':
    return 0;
  case '*':
    return 0;
  case '/':
    return 0;
  default:
    return -1;
  }
  return 0;
}


void print_usage(){

  printf (" calc: invalid option : \n");
  printf (" Usage : float float op \n");
  printf ("   op can be {'+','-','*','/'} \n");
  printf("\n");
  
}


int is_number(char number[]){
  int i = 0;
  if (number[0] == '-'){
    i = 1;
  }
   
  for (; number[i] != 0; i++){
 
    if (!isdigit(number[i])){
      return -1;
    }
  }
  return 0;
}

int test_arg(int argc, char* argv[]){

  if (argc != 4){
    return -1 ;
  }
  
  if (is_number(argv[1]) != 0){

    return -2 ;
  }


  if ( is_number(argv[2]) != 0){

    return -3 ;
  }

  
  if ( is_operator(argv[3][0])  != 0 ){

    return -4 ;
  }

  return 0;
  
}















